/** *********************************************************************************
 *	
 ************************************************************************************
 */
#include <stdio.h>
#include <stdlib.h>
#include "opcode.h"
#include "gr.h"
#include "led.h"

#define	TEST	(1)

OPCODE opcode_init_tab[]={
 //j,Ӗ					,@B		 ,f_emu,d_dis  //z,c,m, --------------------
 {"JMP","JMP always"            ,"00xxdd00"  ,f_JMP,d_JMP},//-,-,-,ɕ򂷂
 {"JBP","Jump if Not Blanking"  ,"00xxdd01"  ,f_JBP,d_JBP},//-,-,-,AԂłȂΕ
 {"JNF","Jump if Not Full"      ,"00xxdd10"  ,f_JNF,d_JNF},//-,-,-,0xffłȂ͕
 {"JF" ,"Jump if Full"          ,"00xxdd11"  ,f_JF ,d_JF },//-,-,-,0xffȂ番
 {"JNC","Jump if Not Carry"     ,"01xxdd00"  ,f_JNC,d_JNC},//-,-,-,L[({[L)Ȃ番
 {"JC" ,"Jump if Carry"         ,"01xxdd01"  ,f_JC ,d_JC },//-,-,-,L[L({[)Ȃ番
 {"JNM","Jump if Not Minus"     ,"01xxdd10"  ,f_JNM,d_JNM},//-,-,-,0܂̓vXȂ番
 {"JM" ,"Jump if Minus"         ,"01xxdd11"  ,f_JM ,d_JM },//-,-,-,}CiXȂ番
 {"LD" ,"LoaD"                  ,"10xx0000"  ,f_LD ,d_LD },//?,0,?,[h
 {"LDT","LoaD Test"             ,"10xx0001"  ,f_LD ,d_LD },//?,0,?,L̎itOXV̂݁j
 {"SBC","SuB. with Borrow"      ,"10xx0010"  ,f_SBB,d_SBB},//?,?,?,{[tZ
 {"SCT","Sub. with Borrow Test" ,"10xx0011"  ,f_SBB,d_SBB},//?,?,?,L̎itOXV̂݁j
 {"SUB","SUBtract"              ,"10xx0100"  ,f_SUB,d_SUB},//?,?,?,Z
 {"SBT","SUBtract Test"         ,"10xx0101"  ,f_SUB,d_SUB},//?,?,?,L̎itOXV̂݁j
 {"OR" ,"OR"                    ,"10xx0110"  ,f_OR ,d_OR },//?,0,?,_a
 {"ORT","OR Test"               ,"10xx0111"  ,f_OR ,d_OR },//?,0,?,L̎itOXV̂݁j
 {"ADD","ADD"                   ,"10xx1000"  ,f_ADD,d_ADD},//?,?,?,Z
 {"ADT","ADd Test"              ,"10xx1001"  ,f_ADD,d_ADD},//?,?,?,L̎itOXV̂݁j
 {"AND","AND"                   ,"10xx1010"  ,f_AND,d_AND},//?,0,?,_
 {"ANT","ANd Test"              ,"10xx1011"  ,f_AND,d_AND},//?,0,?,L̎itOXV̂݁j
 {"ADC","ADd with Carry"        ,"10xx1100"  ,f_ADC,d_ADC},//?,?,?,L[tZ
 {"ACT","Add with Carry Test"   ,"10xx1101"  ,f_ADC,d_ADC},//?,?,?,L̎itOXV̂݁j
 {"XOR","eXcusive OR"           ,"10xx1110"  ,f_XOR,d_XOR},//?,0,?,rI_a
 {"XOT","eXcusive Or Test"      ,"10xx1111"  ,f_XOR,d_XOR},//?,0,?,L̎itOXV̂݁j
 {"LDV","LoaD from Vram"        ,"11xx000-"  ,f_LDV,d_LDV},//?,0,?,rfĨ[h
 {"LDP","LoaD from PC"          ,"11xx001-"  ,f_LDP,d_LDP},//?,0,?,PCi̖߂̃AhXj+ulv=>Acc
 {"ST" ,"STore"                 ,"11xx010-"  ,f_ST ,d_ST },//-,-,-,XgA
 {"SR" ,"ShiFt Right"           ,"11--011-"  ,f_SFR,d_SFR},//?,?,?,EVtgiIyh͖j
 {"SL" ,"ShiFt Left"            ,"11--100-"  ,f_SFL,d_SFL},//?,?,?,VtgiIyh͖j
 {"IN" ,"IN"                    ,"11xx101-"  ,f_IN ,d_IN },//-,-,-,gOXCb`̏Ԃ
 {"OUT","OUT  "                 ,"11xx110-"  ,f_OUT,d_OUT},//-,-,-,AccƎw胁lLEDɕ\
 {"STV","STore to Vram"         ,"11xx1110"  ,f_STV,d_STV},//-,-,-,rfIւ̃XgA
 {"HALT","HALT"                 ,"11xx1111"  ,f_HLT,d_HLT},//-,-,-,~
// {"SCN","SCaN JOY stick port"   ,"11xx1111"  ,f_SCN,d_SCN},//-,-,-,WCXeBbN͂̃XL
// {"STP","STore Program counter" ,"11xx100-"  ,f_STP,d_STP},//-,-,-,vOJE^lۑ
 //j,Ӗ					,@B		 ,f_emu,d_dis  //z,c,m, --------------------
 { NULL,NULL,NULL}
};
OPCODE UNDEFINED_OPCODE=
 {"???","???","--------",f_und,d_und};
//	xx	AhbVO
//	00	Imm8
//	01	Reg8
//	10	[Reg8]
//	11	Imm16

//	dd	fBXvCXg
//	00	Abs
//	01	fwd
//	10	back
//	11	fwd+carry

FILE *ifp;

#define Ropen(name) {ifp=fopen(name,"rb");if(ifp==NULL) \
{ printf("Fatal: can't open file:%s\n",name);exit(1);}  \
}
#define Read(buf,siz)   fread (buf,1,siz,ifp)
#define Rclose()  fclose(ifp)


void memdump(int adr,int len);
void VRAM_output(int adrs,int data);
extern	int	led_trace;

/** *********************************************************************************
 *	߃R[h(code) AOPCODE\̂Pvf(*s)  Ƀ}b`邩.
 ************************************************************************************
 *	}b` 0 Ԃ.
 */
int match_table(OPCODE *s,int code)
{
	char *pat = s->pattern;
	int i,bit,sbit;
	int m=0x80;
	for(i=0;i<8;i++,m>>=1) {
		sbit = *pat++;
		bit = code & m;
		if(sbit == '1') {
			if(bit == 0) return -1;
		}
		if(sbit == '0') {
			if(bit != 0) return -1;
		}
	}
	return 0;	// Matching OK!
}

/** *********************************************************************************
 *	߃R[h code }b`OPCODEopcode_init_tab[]T. 
 ************************************************************************************
 *	A *table ɊۂƃRs[.
 *	ȂAUNDEFINED_OPCODE *table ɊۂƃRs[.
 */
void make_table(OPCODE *table,int code)
{
	OPCODE *s = opcode_init_tab;
	while(s->mnemonic) {
		if(match_table(s,code)==0) {
			*table = *s;
			return;
		}
		s++;
	}
	*table = UNDEFINED_OPCODE;
}

/** *********************************************************************************
 *	opcode_init_tab[]̏ƂɁA\ code_table[256] \z.
 ************************************************************************************
 */
void init_table()
{
	OPCODE *table = code_table;		// \z\ code_table[256]; ̐擪AhX.
	int code;
	for(code=0;code<256;code++,table++) {
		make_table(table,code);
	}
}

/** *********************************************************************************
 *	㑱16bitl݂閽߂Ȃ 1 Ԃ.
 ************************************************************************************
 */
int	is_imm16(int code)
{
	code &= XX_MASK;
	if( code == XX_IMM16 ) return 1;	//㑱 IMM16 l.
	return 0;
}
/** *********************************************************************************
 *	16bit̖߂PtFb`Ďs.
 ************************************************************************************
 */
int	execute_pc()
{
	int rc=0;
	int opcode = memory[ reg.pc++ ];
	OPCODE *table = &code_table[ (opcode >> 8) & 0xff ];
	reg.pc_bak = reg.pc;

	rc = table->emufunc(opcode,table);	//ߎs.
	if(led_trace) {
		table->disfunc(opcode,table);	//tAZu.
	}
	if(rc) return rc;
	return LED_draw(reg.pc,led_trace);

}

//	JOY.
int	 JOY_input()
{
	return 0;
}

void randomize_mem()
{
	int i,j=0;
	for(i=0;i<MEMSIZE;i++) {
		vram[i]=j;
		VRAM_output(i,j);
		j*=0x3d09;j++;
	}
}

int	load_binary(char *fname)
{
	Ropen(fname);
	Read(memory,sizeof(memory));
	Rclose();
	return 0;
}
/** *********************************************************************************
 *	C[`.
 ************************************************************************************
 */
int main(int argc,char **argv)
{
	int rc;
	init_table();

	gr_init(SCREEN_W,SCREEN_H,32,0);

	randomize_mem();
	load_binary(argv[1]);

	reg.pc = 0;

	while(1) {
		rc = execute_pc();
		if(rc) break;
	}
	gr_close();
	return 0;
}


/** *********************************************************************************
 *
 ************************************************************************************
 */
